# importing modules
import sys as sys
import os 
import numpy

# Getting the name of the directory where this file is present.
current = os.path.dirname(os.path.realpath(__file__))  # src
# Getting the parent directory name where the current directory is present.
parent = os.path.dirname(current) # Simulation
# Getting the grandparent directory name
gparent = os.path.dirname(parent) # SinglePASMC
# The path where the simExp.py is saved
mpath = gparent + '\\cellLib\\Scripts'
# appending a path
sys.path.append(mpath)
import simExp
# The simulation .sedml file
simfile = gparent+'\\Experiments\\PASMC_test.sedml'
# Set the parameters for simulation
start, ending, pointInterval = 0, 79, 0.01

savefiles=[parent+'\\simulatedData\\simFig4_0']
indexStart = 0
indexEnd = int(ending/pointInterval) + 1 
varSet = {'output/c_i':{'states':0.25},'output/s_i':{'states':3},'output/v_i':{'states':-25}}
varLoop = {'clamp_para/X_Holding':{'constants':numpy.array([5.9])}}
varSave = {'t':{'voi':False},'output/K_out':{'algebraic':False},'output/c_i':{'states':False},'output/s_i':{'states':False},'output/v_i':{'states':False}}
simExp.simExp(simfile, savefiles,start, ending, pointInterval,indexStart,indexEnd,varSet,varLoop,varSave)

savefiles=[parent+'\\simulatedData\\simFig4_1']
indexStart = 0
indexEnd = int(ending/pointInterval) + 1 
varSet = {'output/c_i':{'states':0.07997},'output/s_i':{'states':0.347},'output/v_i':{'states':-25}}
varLoop = {'clamp_para/X_Holding':{'constants':numpy.array([5.9])}}
varSave = {'t':{'voi':False},'output/K_out':{'algebraic':False},'output/c_i':{'states':False},'output/s_i':{'states':False},'output/v_i':{'states':False}}
simExp.simExp(simfile, savefiles,start, ending, pointInterval,indexStart,indexEnd,varSet,varLoop,varSave)

savefiles=[parent+'\\simulatedData\\simFig4_2']
indexStart = 0
indexEnd = int(ending/pointInterval) + 1 
varSet = {'output/c_i':{'states':0.07997},'output/s_i':{'states':0.347},'output/v_i':{'states':-45}}
varLoop = {'clamp_para/X_Holding':{'constants':numpy.array([5.9])}}
varSave = {'t':{'voi':False},'output/K_out':{'algebraic':False},'output/c_i':{'states':False},'output/s_i':{'states':False},'output/v_i':{'states':False}}
simExp.simExp(simfile, savefiles,start, ending, pointInterval,indexStart,indexEnd,varSet,varLoop,varSave)

savefiles=[parent+'\\simulatedData\\simFig4_3']
indexStart = 0
indexEnd = int(ending/pointInterval) + 1 
varSet = {'output/c_i':{'states':0.1},'output/s_i':{'states':1.06},'output/v_i':{'states':-28}}
varLoop = {'clamp_para/X_Holding':{'constants':numpy.array([5.9])}}
varSave = {'t':{'voi':False},'output/K_out':{'algebraic':False},'output/c_i':{'states':False},'output/s_i':{'states':False},'output/v_i':{'states':False}}
simExp.simExp(simfile, savefiles,start, ending, pointInterval,indexStart,indexEnd,varSet,varLoop,varSave)

start, ending, pointInterval = 0, 150, 0.01
savefiles=[parent+'\\simulatedData\\simFig4_4']
indexStart = 0
indexEnd = int(ending/pointInterval) + 1 
varSet = {'clamp_para/t_ss':{'constants':151},'output/c_i':{'states':0.1},'output/s_i':{'states':1.06},'output/v_i':{'states':-28}}
varLoop = {'clamp_para/X_Holding':{'constants':numpy.array([5.9])}}
varSave = {'t':{'voi':False},'output/K_out':{'algebraic':False},'output/c_i':{'states':False},'output/s_i':{'states':False},'output/v_i':{'states':False}}
simExp.simExp(simfile, savefiles,start, ending, pointInterval,indexStart,indexEnd,varSet,varLoop,varSave)

